﻿"""
    COPYRIGHT 2013-2019 ESRI
    
    TRADE SECRETS: ESRI PROPRIETARY AND CONFIDENTIAL
    Unpublished material - all rights reserved under the
    Copyright Laws of the United States.
    
    For additional information, contact:
    Environmental Systems Research Institute, Inc.
    Attn: Contracts Dept
    380 New York Street
    Redlands, California, USA 92373
    
    email: contracts@esri.com
"""
#Cartographic Information Model generated file - do not modify
from .CIMEnum import *
from .CIMExternal import *
from .ArcpyHelper import GetPythonClass

class CIMColor():
    """
      Supports colors in the CIM model by providing low level access 
      to properties common amongst all color types.
    """
    colorSpace = 'CIMColorSpace'
    values = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMColorRamp():
    """
      Supports color ramp schemes in the CIM model by providing low level 
      access to properties common amongst all color ramp types.
    """
    colorSpace = 'CIMColorSpace'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMColorSpace():
    """
      Supports colors spaces by providing a common base type for all 
      color spaces.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMCMYKColor(CIMColor):
    """
      Represents a color in the CMYK color model.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMContinuousColorRamp(CIMColorRamp):
    """
      Supports continuous color ramp schemes by providing low level access 
      to properties common amongst all continuous color ramp types.
    """
    fromColor = 'CIMColor'
    toColor = 'CIMColor'
    primitiveName = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMFixedColorRamp(CIMColorRamp):
    """
      Represents a color scheme composed of discrete colors.
    """
    colors = []
    arrangement = FixedColorRampArrangementType.Default
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGrayColor(CIMColor):
    """
      Represents a grayscale color defined by lightness.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMHSLColor(CIMColor):
    """
      Represents a color defined by hue, saturation, and lightness.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMHSVColor(CIMColor):
    """
      Represents a color defined by hue, saturation, and brightness (value).
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMICCColorSpace(CIMColorSpace):
    """
      Represents a color space defined by an International Color Consortium 
      (ICC) color profile.
    """
    url = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLABColor(CIMColor):
    """
      Represents a color defined in the LAB color space.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLinearContinuousColorRamp(CIMContinuousColorRamp):
    """
      Represents a linear continuous color ramp scheme.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMultipartColorRamp(CIMColorRamp):
    """
      Represents a multipart color ramp scheme.
    """
    colorRamps = []
    weights = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMPolarContinuousColorRamp(CIMContinuousColorRamp):
    """
      Represents a polar continuous color ramp scheme.
    """
    interpolationSpace = ColorSpaceType.HSV
    polarDirection = PolarDirection.Auto
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRGBColor(CIMColor):
    """
      Represents a color in the RGB color model.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMRandomHSVColorRamp(CIMColorRamp):
    """
      Represents a random HSV color ramp scheme.
    """
    minH = 0
    maxH = 0
    minS = 0
    maxS = 0
    minV = 0
    maxV = 0
    minAlpha = 0
    maxAlpha = 100
    seed = 0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSpotColor(CIMColor):
    """
      Represents a spot color.
    """
    name = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSpotColorSpace(CIMColorSpace):
    """
      Represents a color space for spot colors.
    """
    description = str()
    name = str()
    alternativeColor = 'CIMColor'
    bookColor = 'CIMColor'
    bookID = str()
    isReferencedColor = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMXYZColor(CIMColor):
    """
      Represents a color in the XYZ color model.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
