﻿"""
    COPYRIGHT 2013-2019 ESRI
    
    TRADE SECRETS: ESRI PROPRIETARY AND CONFIDENTIAL
    Unpublished material - all rights reserved under the
    Copyright Laws of the United States.
    
    For additional information, contact:
    Environmental Systems Research Institute, Inc.
    Attn: Contracts Dept
    380 New York Street
    Redlands, California, USA 92373
    
    email: contracts@esri.com
"""
#Cartographic Information Model generated file - do not modify
from .CIMEnum import *
from .CIMExternal import *
from .ArcpyHelper import GetPythonClass

class CIMGeneralPlacementProperties():
    """
      Represents general placement properties. This is base class for 
      general placement properties for each label engine.
    """
    drawUnplacedLabels = False
    invertedLabelTolerance = 2.0
    rotateLabelWithDisplay = False
    unplacedLabelColor = 'CIMColor'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLabelClass():
    """
      Represents a label class which describes how to generate a set 
      of text labels from a group of features in a feature layer.
    """
    expressionTitle = str()
    expression = str()
    expressionEngine = LabelExpressionEngine.VBScript
    featuresToLabel = FeaturesToLabel.AllVisibleFeatures
    maplexLabelPlacementProperties = 'CIMMaplexLabelPlacementProperties'
    maximumScale = 0.0
    minimumScale = 0.0
    name = str()
    priority = -1
    standardLabelPlacementProperties = 'CIMStandardLabelPlacementProperties'
    textSymbol = 'CIMSymbolReference'
    useCodedValue = True
    whereClause = str()
    visibility = False
    iD = -1
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLabelClassProperties():
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLabelPlacementProperties():
    """
      Represents label placement properties.
    """
    featureType = LabelFeatureType.Line
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMaplexDictionary():
    """
      Represents a Maplex dictionary.
    """
    name = str()
    maplexDictionary = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMaplexDictionaryEntry():
    """
      Represents a Maplex dictionary entry.
    """
    abbreviation = str()
    text = str()
    maplexAbbreviationType = MaplexAbbreviationType.Translation
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMaplexExternalZonePriorities():
    """
      Represents Maplex external zone priorities.
    """
    aboveLeft = 4
    aboveCenter = 2
    aboveRight = 1
    centerRight = 3
    belowRight = 5
    belowCenter = 7
    belowLeft = 8
    centerLeft = 6
    center = 0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMaplexInternalZonePriorities():
    """
      Represents Maplex internal zone priorities.
    """
    aboveLeft = 0
    aboveCenter = 0
    aboveRight = 0
    centerRight = 0
    belowRight = 0
    belowCenter = 0
    belowLeft = 0
    centerLeft = 0
    center = 1
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMaplexKeyNumberGroup():
    """
      Represents a Maplex key number group.
    """
    delimiterCharacter = str()
    horizontalAlignment = MaplexKeyNumberHorizontalAlignment.Left
    maximumNumberOfLines = 80
    minimumNumberOfLines = 2
    name = str()
    numberResetType = MaplexKeyNumberResetType.eNone
    keyNumberMethod = MaplexKeyNumberMethod.PreventUnplacedLabels
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMaplexLabelStackingProperties():
    """
      Represents Maplex label stacking properties.
    """
    stackAlignment = MaplexStackingAlignment.ChooseBest
    maximumNumberOfLines = 3
    minimumNumberOfCharsPerLine = 3
    maximumNumberOfCharsPerLine = 24
    separators = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMaplexOffsetAlongLineProperties():
    """
      Represents Maplex offset along the line properties.
    """
    placementMethod = MaplexOffsetAlongLineMethod.BestPositionAlongLine
    labelAnchorPoint = MaplexLabelAnchorPoint.CenterOfLabel
    distance = 0.0
    tolerance = 0.0
    distanceUnit = MaplexUnit.Percentage
    useLineDirection = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMaplexRotationProperties():
    """
      Represents Maplex rotation properties.
    """
    enable = False
    rotationType = MaplexLabelRotationType.Arithmetic
    rotationField = str()
    perpendicularToAngle = False
    alignLabelToAngle = False
    alignmentType = MaplexRotationAlignmentType.Straight
    additionalAngle = 0
    rotationExpressionInfo = 'CIMExpressionInfo'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMaplexStackingSeparator():
    """
      Represents a Maplex stacking separator.
    """
    separator = str()
    visible = False
    splitForced = False
    splitAfter = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMaplexStrategyPriorities():
    """
      Represents Maplex strategy priorities.
    """
    stacking = 1
    overrun = 2
    fontCompression = 3
    fontReduction = 4
    abbreviation = 5
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMStandardLineLabelPosition():
    """
      Represents standard label engine line label position.
    """
    produceCurvedLabels = False
    above = True
    below = False
    onTop = False
    left = False
    right = False
    inLine = True
    atStart = False
    atEnd = False
    parallel = True
    perpendicular = False
    horizontal = False
    offset = 0.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMStandardLineLabelPriorities():
    """
      Represents standard label engine line label priorities.
    """
    aboveBefore = 0
    aboveStart = 3
    aboveAlong = 3
    aboveEnd = 3
    aboveAfter = 0
    centerBefore = 0
    centerStart = 3
    centerAlong = 3
    centerEnd = 3
    centerAfter = 0
    belowBefore = 0
    belowStart = 3
    belowAlong = 3
    belowEnd = 3
    belowAfter = 0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMStandardPointPlacementPriorities():
    """
      Represents standard label engine point placement priorities.
    """
    aboveLeft = 2
    aboveCenter = 2
    aboveRight = 1
    centerLeft = 3
    centerRight = 2
    belowLeft = 3
    belowCenter = 3
    belowRight = 2
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMaplexGeneralPlacementProperties(CIMGeneralPlacementProperties):
    """
      Represents Maplex general placement properties.
    """
    allowBorderOverlap = False
    dictionaries = []
    keyNumberGroups = []
    placementQuality = MaplexQualityType.Low
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMMaplexLabelPlacementProperties(CIMLabelPlacementProperties):
    """
      Represents Maplex label placement properties.
    """
    alignLabelToLineDirection = False
    allowAsymmetricOverrun = False
    allowStraddleStacking = False
    alternateLabelExpressionInfo = 'CIMExpressionInfo'
    avoidPolygonHoles = True
    backgroundLabel = False
    boundaryLabelingAllowHoles = False
    boundaryLabelingAllowSingleSided = False
    boundaryLabelingSingleSidedOnLine = False
    canAbbreviateLabel = False
    canFlipStackedStreetLabel = False
    canKeyNumberLabel = False
    canOverrunFeature = True
    canPlaceLabelOnTopOfFeature = False
    canPlaceLabelOutsidePolygon = True
    canReduceFontSize = False
    canReduceLeading = False
    canRemoveOverlappingLabel = True
    canShiftPointLabel = False
    canStackLabel = True
    canTruncateLabel = False
    canUseAlternateLabelExpression = False
    connectionType = MaplexConnectionType.Unambiguous
    constrainOffset = MaplexConstrainOffset.NoConstraint
    contourAlignmentType = MaplexContourAlignmentType.Page
    contourLadderType = MaplexContourLadderType.Straight
    contourMaximumAngle = 90
    dictionaryName = str()
    enableConnection = True
    enablePointPlacementPriorities = False
    enablePolygonFixedPosition = False
    enableSecondaryOffset = False
    featureWeight = 100
    fontHeightReductionLimit = 4.0
    fontHeightReductionStep = 0.5
    fontWidthReductionLimit = 90.0
    fontWidthReductionStep = 5.0
    graticuleAlignment = False
    graticuleAlignmentType = MaplexGraticuleAlignmentType.Straight
    isLabelBufferHardConstraint = False
    isMinimumSizeBasedOnArea = False
    isOffsetFromFeatureGeometry = False
    keyNumberGroupName = str()
    labelBuffer = 15
    labelLargestPolygon = True
    labelPriority = -1
    labelStackingProperties = 'CIMMaplexLabelStackingProperties'
    lineFeatureType = MaplexLineFeatureType.General
    linePlacementMethod = MaplexLinePlacementMethod.OffsetCurvedFromLine
    maximumCharacterSpacing = 0.0
    maximumLabelOverrun = 36.0
    maximumLabelOverrunUnit = MaplexUnit.Point
    maximumWordSpacing = 0.0
    minimumEndOfStreetClearance = 0.0
    minimumFeatureSizeUnit = MaplexUnit.Map
    minimumRepetitionInterval = 0.0
    minimumSizeForLabeling = 0.0
    multiPartOption = MaplexMultiPartOption.OneLabelPerPart
    neverRemoveLabel = False
    offsetAlongLineProperties = 'CIMMaplexOffsetAlongLineProperties'
    pointExternalZonePriorities = 'CIMMaplexExternalZonePriorities'
    pointPlacementMethod = MaplexPointPlacementMethod.AroundPoint
    polygonAnchorPointType = MaplexAnchorPointType.GeometricCenter
    polygonBoundaryWeight = 200
    polygonExternalZones = 'CIMMaplexExternalZonePriorities'
    polygonFeatureType = MaplexPolygonFeatureType.General
    polygonInternalZones = 'CIMMaplexInternalZonePriorities'
    polygonPlacementMethod = MaplexPolygonPlacementMethod.CurvedInPolygon
    preferHorizontalPlacement = False
    preferLabelNearJunction = False
    preferLabelNearJunctionClearance = 0.0
    preferLabelNearMapBorder = False
    preferLabelNearMapBorderClearance = 0.0
    preferredEndOfStreetClearance = 0.0
    primaryOffset = 1.0
    primaryOffsetUnit = MaplexUnit.Point
    removeExtraLineBreaks = False
    removeExtraWhiteSpace = True
    repeatLabel = False
    repetitionIntervalUnit = MaplexUnit.Map
    rotationProperties = 'CIMMaplexRotationProperties'
    secondaryOffset = 100.0
    secondaryOffsetMaximum = 0.0
    secondaryOffsetMinimum = 0.0
    spreadCharacters = False
    spreadWords = False
    strategyPriorities = 'CIMMaplexStrategyPriorities'
    thinDuplicateLabels = False
    thinningDistance = 0.0
    thinningDistanceUnit = MaplexUnit.Map
    truncationMarkerCharacter = str()
    truncationMinimumLength = 1
    truncationPreferredCharacters = str()
    useExactSymbolOutline = False
    truncationExcludedCharacters = str()
    polygonAnchorPointPerimeterInset = 0.0
    polygonAnchorPointPerimeterInsetUnit = MaplexUnit.Point
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMStandardGeneralPlacementProperties(CIMGeneralPlacementProperties):
    """
      Represents standard label engine general placement properties.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMStandardLabelPlacementProperties(CIMLabelPlacementProperties):
    """
      Represents standard label engine label placement properties.
    """
    featureWeight = StandardFeatureWeight.eNone
    labelWeight = StandardLabelWeight.High
    numLabelsOption = StandardNumLabelsOption.OneLabelPerName
    lineLabelPosition = 'CIMStandardLineLabelPosition'
    lineLabelPriorities = 'CIMStandardLineLabelPriorities'
    pointPlacementMethod = StandardPointPlacementMethod.AroundPoint
    pointPlacementPriorities = 'CIMStandardPointPlacementPriorities'
    pointPlacementAngles = []
    bufferRatio = 0.0
    lineOffset = 0.0
    maxDistanceFromTarget = 0.0
    rotationType = StandardLabelRotationType.Arithmetic
    rotationField = str()
    perpendicularToAngle = False
    polygonPlacementMethod = StandardPolygonPlacementMethod.AlwaysHorizontal
    placeOnlyInsidePolygon = False
    allowOverlappingLabels = False
    def __init__(self, *args, **Kwargs):
        pass
    
