﻿"""
    COPYRIGHT 2013-2019 ESRI
    
    TRADE SECRETS: ESRI PROPRIETARY AND CONFIDENTIAL
    Unpublished material - all rights reserved under the
    Copyright Laws of the United States.
    
    For additional information, contact:
    Environmental Systems Research Institute, Inc.
    Attn: Contracts Dept
    380 New York Street
    Redlands, California, USA 92373
    
    email: contracts@esri.com
"""
#Cartographic Information Model generated file - do not modify
from .CIMEnum import *
from .CIMExternal import *
from .ArcpyHelper import GetPythonClass

class CIM3DLayerProperties():
    """
      Represents 3D layer properties which contain properties used for 
      3D draw.
    """
    castShadows = True
    isLayerLit = True
    layerFaceCulling = FaceCulling3D.eNone
    maxDistance = 0.0
    maxPreloadDistance = 0.0
    minDistance = 0.0
    minPreloadDistance = 0.0
    preloadTextureCutoffHigh = 0.3
    preloadTextureCutoffLow = 0.6
    textureCutoffHigh = 0.3
    textureCutoffLow = 0.6
    textureDownscalingFactor = 0
    useCompressedTextures = True
    verticalExaggeration = 1.0
    exaggerationMode = ExaggerationMode.ScaleZ
    verticalUnit = str()
    depthPriority = 0
    lighting = Lighting3D.OneSideDataNormal
    optimizeMarkerTransparency = False
    useDepthWritingForTransparency = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMDefinitionFilter():
    """
      Contains filters so that only features satisfying these definitions 
      will be displayed.
    """
    name = str()
    definitionExpression = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMElementStorage():
    """
      Represents a series of graphic elements stored offline.
    """
    elements = []
    """
      Represents a series of graphic elements stored offline.
    """
    spatialReference = GetPythonClass('arcpy', 'SpatialReference')
    symbols = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMEyeDomeLighting():
    """
      Represents eye-dome lighting properties.
    """
    isEnabled = True
    strength = 0.0
    radius = 1.0
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLayerElevationSurface():
    """
      Represents a layer elevation surface.
    """
    offsetZ = 0.0
    mapElevationID = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLayerTemplate():
    """
      Represents a layer template.
    """
    uRI = str()
    layerTemplateId = str()
    parameters = {}
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSubLayerBase():
    """
      Represents sublayer base class.
    """
    description = str()
    expanded = False
    maxScale = 0
    minScale = 0
    name = str()
    showLegends = True
    subLayerID = str()
    visibility = True
    serviceLayerID = -1
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSymbolLayerDrawing():
    """
      Represents symbol layer drawing properties.
    """
    symbolLayers = []
    useSymbolLayerDrawing = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSymbolLayerIdentifier():
    """
      Represents symbol layer identifier.
    """
    symbolLayerName = str()
    def __init__(self, *args, **Kwargs):
        pass
    
from .CIMCore import CIMDefinition
class CIMBaseLayer(CIMDefinition):
    """
      Represents the base layer class.
    """
    attribution = str()
    description = str()
    layerElevation = 'CIMLayerElevationSurface'
    expanded = False
    layer3DProperties = 'CIM3DLayerProperties'
    layerMasks = []
    layerType = MapLayerType.Operational
    maxScale = 0.0
    minScale = 0.0
    showLegends = True
    transparency = 0.0
    visibility = True
    displayCacheType = DisplayCacheType.Permanent
    maxDisplayCacheAge = 5.0
    layerTemplate = 'CIMLayerTemplate'
    popupInfo = 'CIMPopupInfo'
    showPopups = True
    serviceLayerID = -1
    charts = []
    searchable = False
    refreshRate = -1.0
    refreshRateUnit = esriTimeUnits.esriTimeUnitsSeconds
    showMapTips = False
    customProperties = []
    webMapLayerID = str()
    blendingMode = BlendingMode.Alpha
    def __init__(self, *args, **Kwargs):
        pass
    
from .CIMVectorLayers import CIMDataConnection
class CIMKMLDataConnection(CIMDataConnection):
    """
      Represents a KML data connection.
    """
    kMLURI = str()
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMCompositeSubLayer(CIMSubLayerBase):
    """
      Represents a composite sublayer.
    """
    subLayers = []
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGeodatabaseErrorLayer(CIMBaseLayer):
    """
      Represents GDB Error tables as a composite layer and draws the 
      errors.
    """
    pointLayer = str()
    lineLayer = str()
    polygonLayer = str()
    objectTable = str()
    workspaceConnection = 'CIMWorkspaceConnection'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGraphicsLayer(CIMBaseLayer):
    """
      Represents a layer of simple graphic elements.
    """
    elementStorageURI = str()
    referenceScale = 0.0
    barrierWeight = BarrierWeight.High
    snappable = True
    selectable = True
    showInvisibleGraphics = False
    invisibleGraphicsColor = 'CIMColor'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMGroupLayer(CIMBaseLayer):
    """
      Represents a group layer which is a simple ordered collection of 
      other layers.
    """
    layers = []
    symbolLayerDrawing = 'CIMSymbolLayerDrawing'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMKMLLayer(CIMBaseLayer):
    """
      Represents a KML layer.
    """
    dataConnection = 'CIMKMLDataConnection'
    selectable = False
    selectionColor = 'CIMColor'
    useSelectionColor = False
    labelVisibility = True
    textSymbol = 'CIMTextSymbol'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMSubLayer(CIMSubLayerBase):
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMTopologyLayer(CIMBaseLayer):
    """
      Represents a topology dataset as a layer and draws its errors,
        /// exceptions, and areas in need of validation.
    """
    allLayers = []
    topologyConnection = 'CIMDataConnection'
    def __init__(self, *args, **Kwargs):
        pass
    
