﻿"""
    COPYRIGHT 2013-2019 ESRI
    
    TRADE SECRETS: ESRI PROPRIETARY AND CONFIDENTIAL
    Unpublished material - all rights reserved under the
    Copyright Laws of the United States.
    
    For additional information, contact:
    Environmental Systems Research Institute, Inc.
    Attn: Contracts Dept
    380 New York Street
    Redlands, California, USA 92373
    
    email: contracts@esri.com
"""
#Cartographic Information Model generated file - do not modify
from .CIMEnum import *
from .CIMExternal import *
from .ArcpyHelper import GetPythonClass

class CIMLinkChartEntity():
    """
      Represents a link chart entity.
    """
    iD = str()
    name = str()
    layerURI = str()
    keyFieldName = str()
    labelFieldName = str()
    nonSpatial = False
    drawingInfo = 'CIMLinkChartNodeDrawingInfo'
    labelingInfo = 'CIMLinkChartNodeLabelingInfo'
    expanded = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLinkChartLabelingInfo():
    """
      Represents the link chart labeling information.
    """
    showLabels = False
    labelFontFamilyName = str()
    labelFontStyleName = str()
    labelFontType = FontType.Unspecified
    labelFontSize = 16
    labelFontColor = 'CIMColor'
    labelBackgroundColor = 'CIMColor'
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLinkChartLinkDrawingInfo():
    """
      Represents the link chart link drawing information.
    """
    linkColor = 'CIMColor'
    linkWidth = 4
    linkDashStyle = LinkChartLinkDashStyle.Solid
    showDirection = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLinkChartNodeDrawingInfo():
    """
      Represents the link chart node drawing information.
    """
    collapseDuplicates = True
    nodeSymbology = LinkChartSymbolizationSource.MapSymbology
    overrideSymbol = 'CIMSymbolReference'
    overrideOverviewSymbolColor = False
    overviewSymbolColor = 'CIMColor'
    showNodeFrames = False
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLinkChartRelationship():
    """
      Represents a link chart relationship.
    """
    iD = str()
    name = str()
    sourceEntityId = str()
    sourceEntityBackingField = str()
    targetEntityId = str()
    targetEntityBackingField = str()
    drawingInfo = 'CIMLinkChartLinkDrawingInfo'
    labelingInfo = 'CIMLinkChartLinkLabelingInfo'
    expanded = False
    def __init__(self, *args, **Kwargs):
        pass
    
from .CIMCore import CIMDefinition
class CIMLinkChartBase(CIMDefinition):
    """
      Represents the base definition of a link chart.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLinkChart(CIMLinkChartBase):
    """
      Represents a link chart.
    """
    entities = []
    relationships = []
    layout = LinkChartLayoutAlgorithm.Clustered
    graphMLURI = str()
    expanded = False
    locked = False
    interactiveLayoutMode = True
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLinkChartLinkLabelingInfo(CIMLinkChartLabelingInfo):
    """
      Represents the link chart link labeling information.
    """
    labelPlacement = LinkChartLinkLabelPlacement.Parallel
    def __init__(self, *args, **Kwargs):
        pass
    
class CIMLinkChartNodeLabelingInfo(CIMLinkChartLabelingInfo):
    """
      Represents the link chart node labeling information.
    """
    def __init__(self, *args, **Kwargs):
        pass
    
